VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Object = "{48E59290-9880-11CF-9754-00AA00C00908}#1.0#0"; "msinet.ocx"
Begin VB.Form Form1 
   Caption         =   "howto_sync_download"
   ClientHeight    =   4410
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   9195
   LinkTopic       =   "Form1"
   ScaleHeight     =   4410
   ScaleWidth      =   9195
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtHostUrl 
      Height          =   285
      Left            =   1320
      TabIndex        =   4
      Text            =   "http://www.vb-helper.com/TestUpload"
      Top             =   120
      Width           =   3615
   End
   Begin VB.CommandButton cmdListFiles 
      Caption         =   "List Files"
      Height          =   375
      Left            =   2400
      TabIndex        =   3
      Top             =   840
      Width           =   975
   End
   Begin VB.TextBox txtToDirectory 
      Height          =   285
      Left            =   1320
      TabIndex        =   1
      Top             =   480
      Width           =   3615
   End
   Begin VB.CommandButton cmdDownload 
      Caption         =   "Download"
      Height          =   375
      Left            =   2400
      TabIndex        =   0
      Top             =   3360
      Width           =   975
   End
   Begin InetCtlsObjects.Inet inetFtp 
      Left            =   5160
      Top             =   480
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
   End
   Begin MSComctlLib.ListView lvwFiles 
      Height          =   1575
      Left            =   120
      TabIndex        =   2
      Top             =   1320
      Width           =   6375
      _ExtentX        =   11245
      _ExtentY        =   2778
      View            =   3
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      Checkboxes      =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   3
      BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Text            =   "File"
         Object.Width           =   5080
      EndProperty
      BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   1
         Text            =   "Local Date"
         Object.Width           =   5080
      EndProperty
      BeginProperty ColumnHeader(3) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   2
         Text            =   "Remote Date"
         Object.Width           =   5080
      EndProperty
   End
   Begin VB.Label Label1 
      Caption         =   "Host URL"
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   6
      Top             =   120
      Width           =   1095
   End
   Begin VB.Label Label1 
      Caption         =   "To Directory"
      Height          =   255
      Index           =   1
      Left            =   120
      TabIndex        =   5
      Top             =   480
      Width           =   1095
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const FILELIST_HEADER As String = "File List"

Private Enum DownloadResults
    dl_Ok
    dl_NotFound
    dl_Error
End Enum

Private m_HostUrl As String
Private m_ToDir As String

Private m_FileData As Collection

' Download checked files.
Private Sub cmdDownload_Click()
Dim i As Integer
Dim from_file As String
Dim to_file As String

    Screen.MousePointer = vbHourglass
    DoEvents

    For i = 1 To lvwFiles.ListItems.Count
        If lvwFiles.ListItems(i).Checked Then
            from_file = m_HostUrl & lvwFiles.ListItems(i).Text
            to_file = m_ToDir & lvwFiles.ListItems(i).Text
            Select Case DownloadFile(from_file, to_file)
                Case dl_Error, dl_NotFound
                    If MsgBox("Error downloading file '" & _
                        from_file & "' to '" & _
                        to_file & "'" & vbCrLf & _
                        "Continue?", _
                        vbYesNo Or vbQuestion, _
                        "Continue?") = vbNo _
                    Then
                        Exit For
                    End If
                Case dl_Ok
                    lvwFiles.ListItems(i).Checked = False
                    lvwFiles.ListItems(i).SubItems(1) = Format$(Now)
            End Select
        End If
    Next i

    Screen.MousePointer = vbDefault
    MsgBox "Download complete", vbInformation Or vbOKOnly, "Done"
End Sub

' Get the remote list of files and update times.
' Compare this to the modification times of the files
' in the local directory.
Private Sub cmdListFiles_Click()
Dim remote_file_list As String
Dim local_file_list As String
Dim file_list_text As String
Dim lines() As String
Dim fields() As String
Dim i As Integer
Dim file_data As FileData
Dim new_item As ListItem

    Screen.MousePointer = vbHourglass
    lvwFiles.ListItems.Clear
    DoEvents

    ' Get the parameters.
    m_HostUrl = txtHostUrl.Text
    If Right$(m_HostUrl, 1) <> "/" Then m_HostUrl = m_HostUrl & "/"
    If Left$(LCase$(m_HostUrl), 7) <> "http://" Then m_HostUrl = "http://" & m_HostUrl

    m_ToDir = txtToDirectory.Text
    If Right$(m_ToDir, 1) <> "\" Then m_ToDir = m_ToDir & "\"

    ' Get information about the local files.
    Set m_FileData = GetLocalFileData(m_ToDir)

    ' Get the remote list of files.
    remote_file_list = m_HostUrl & "filelist"
    local_file_list = m_ToDir & "filelist"
    Select Case DownloadFile(remote_file_list, local_file_list)
        Case dl_Error, dl_NotFound
            ' We didn't get the file list.
            MsgBox "Error getting file list '" & _
                remote_file_list & "'", _
                vbExclamation Or vbOKOnly, _
                "Error"
            On Error Resume Next
            Kill local_file_list
            On Error GoTo 0
            Screen.MousePointer = vbDefault
            Exit Sub
        Case dl_Ok
            ' Read the file.
            file_list_text = GetFileContents(local_file_list)

            ' Verify that it looks like a file list.
            If Left$(file_list_text, Len(FILELIST_HEADER)) <> FILELIST_HEADER Then
                ' We didn't get the file list.
                MsgBox "Error getting file list '" & _
                    remote_file_list & "'", _
                    vbExclamation Or vbOKOnly, _
                    "Error"
                On Error Resume Next
                Kill local_file_list
                On Error GoTo 0
                Exit Sub
            End If
    End Select

    ' Set the remote dates for the files.
    lines = Split(file_list_text, vbCrLf)
    For i = LBound(lines) + 1 To UBound(lines)
        ' Skip blank lines.
        If Len(lines(i)) > 0 Then
            fields = Split(lines(i), ",")
            ' Get the file's FileData.
            On Error Resume Next
            Set file_data = m_FileData(fields(0))
            If Err.Number = 0 Then
                ' We have the file locally.
                file_data.RemoteDate = CDate(fields(1))
            Else
                ' We don't have the file locally.
                ' Add an entry for it.
                Err.Clear
                Set file_data = New FileData
                file_data.FileName = fields(0)
                file_data.LocalDate = #1/1/1980 12:00:01 AM#
                file_data.RemoteDate = CDate(fields(1))
                m_FileData.Add file_data
            End If
            On Error GoTo 0
        End If
    Next i

    ' Delete the file list.
    On Error Resume Next
    Kill local_file_list
    On Error GoTo 0

    ' Display the list of files.
    For Each file_data In m_FileData
        If file_data.FileName <> "filelist" Then
            Set new_item = lvwFiles.ListItems.Add(Text:=file_data.FileName)
            new_item.ListSubItems.Add Text:=Format$(file_data.LocalDate)
            new_item.ListSubItems.Add Text:=Format$(file_data.RemoteDate)
            new_item.Checked = file_data.RemoteDate > file_data.LocalDate
        End If
    Next file_data

    Screen.MousePointer = vbDefault
End Sub

' Get the file's contents.
Private Function GetFileContents(ByVal file_name As String) As String
Dim fnum As Integer

    ' Open the file.
    fnum = FreeFile
    Open file_name For Input As fnum

    ' Grab the file's contents.
    GetFileContents = Input(LOF(fnum), fnum)

    ' Close the file.
    Close fnum
End Function

' Download a file. Return dl_Ok, dl_NotFound, or dl_Error.
Private Function DownloadFile(ByVal source_file As String, ByVal dest_file As String) As DownloadResults
Dim bytes() As Byte
Dim fnum As Integer

    ' Get the file's contents.
    On Error GoTo DownloadError
    bytes() = inetFtp.OpenURL(source_file, icByteArray)

    If UBound(bytes) = -1 Then
        ' Not found.
        DownloadFile = dl_NotFound
    Else
        ' Write the contents into the destination file.
        On Error Resume Next
        Kill dest_file
        On Error GoTo DownloadError

        fnum = FreeFile
        Open dest_file For Binary Access Write As #fnum
        Put #fnum, , bytes()
        Close #fnum

        DownloadFile = dl_Ok
    End If

    Exit Function

DownloadError:
    MsgBox "Error " & Err.Number & _
        " downloading file '" & _
        source_file & "' to '" & _
        dest_file & "'." & vbCrLf & Err.Description, _
        vbExclamation Or vbOKOnly, _
        "Download Error"
    DownloadFile = dl_Error
    Exit Function
End Function


' Get information about the local files.
Private Function GetLocalFileData(ByVal from_dir As String) As Collection
Dim results As Collection
Dim file_name As String
Dim file_data As FileData

    Set results = New Collection
    file_name = Dir$(from_dir & "*.*", vbNormal)
    Do While Len(file_name) > 0
        Set file_data = New FileData
        file_data.FileName = file_name
        file_data.LocalDate = FileDateTime(from_dir & file_name)
        file_data.RemoteDate = #1/1/1980 12:00:01 AM#
        results.Add file_data, file_name

        file_name = Dir$(, vbNormal)
    Loop

    Set GetLocalFileData = results
End Function


Private Sub Form_Load()
Dim app_path As String

    app_path = App.Path
    If Right$(app_path, 1) <> "\" Then app_path = app_path & "\"
    txtToDirectory.Text = app_path & "TestDownload"
End Sub

Private Sub Form_Resize()
Dim wid As Single
Dim hgt As Single

    wid = ScaleWidth - txtHostUrl.Left - 120
    If wid < 120 Then wid = 120
    txtHostUrl.Width = wid
    txtToDirectory.Width = wid

    cmdListFiles.Left = (ScaleWidth - cmdListFiles.Width) / 2
    cmdDownload.Move cmdListFiles.Left, ScaleHeight - cmdDownload.Height - 120

    wid = ScaleWidth - 2 * 120
    If wid < 120 Then wid = 120
    hgt = cmdDownload.Top - lvwFiles.Top - 120
    If hgt < 120 Then hgt = 120
    lvwFiles.Move lvwFiles.Left, lvwFiles.Top, wid, hgt
End Sub
